// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "SphereCollider.hpp"

using namespace Dawn;

SphereCollider::SphereCollider(SceneItem *item) : Collider3D(item) {

}

enum Collider3DType SphereCollider::getColliderType() {
  return COLLIDER3D_TYPE_SPHERE;
}

bool_t SphereCollider::performRaycast(
  struct Collider3DRayResult *result,
  struct Ray3D ray
) {
  assertNotNull(result);

  return raytestSphere(
    ray,
    { .center = transform->getLocalPosition(), .radius = this->radius },
    &result->point,
    &result->normal,
    &result->distance
  );
}