// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "scene/SceneItemComponent.hpp"
#include "scene/components/entity/EntityFaction.hpp"
#include "scene/components/physics/2d/TriggerController2D.hpp"
#include "scene/components/entity/EntityHealth.hpp"
#include "scene/components/entity/EntityFaction.hpp"

namespace Dawn {
  class HurtHazard : public SceneItemComponent {
    private:
      std::function<void()> evtTriggerEnter;

    public:
      // @optional
      float_t hitKnockback = 20.0f;
      // @optional
      int32_t damage = 1;
      // @optional
      enum Faction faction = FACTION_NONE;
      // @optional
      StateProperty<TriggerController2D*> trigger;
      
      HurtHazard(SceneItem* item);

      void onStart() override;
  };
}